import java.applet.Applet;
import java.applet.AppletStub;
import java.awt.Dimension;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Properties;

import javax.swing.JFrame;

/**
 * An {@link Applet} used for loading the rs2-client.
 * @author Thomas Le Godais <thomaslegodais@live.com>
 */
public class RS2Loader extends Applet implements AppletStub {

	/**
	 * An generated serial UID.
	 */
	private static final long serialVersionUID = 1670498001014004354L;

	/**
	 * A flag used to indicate if ISAAC is enabled.
	 */
	public static final boolean ISAAC_ENABLED = false;

	/**
	 * A flag used to indiciate if RSA is enabled.
	 */
	public static final boolean RSA_ENABLED = false;

	/**
	 * The parameters of the client.
	 */
	private Properties parameters = new Properties();
	
	/**
	 * The current frame of the client application.
	 */
	public JFrame clientFrame = null;
	
	/**
	 * The main entry point of the current application.
	 * @param args The command line arguments.
	 */
	public static void main(String... args) {
		RS2Loader rsLoader = new RS2Loader();
		rsLoader.doFrame();
	}
	
	/**
	 * Performs the operations needed to show the client.
	 */
	private void doFrame() {
		readParameters();
		openFrame();
		startClient();
		clientFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);		
	}

	/**
	 * Starts the actual client.
	 */
	private void startClient() {
		try {
			client client = new client();
			Class9 class9 = new Class9(false, this, 32, "runescape", 26);
			
			Applet_Sub1.providesignlink(class9);
			client.init();
			client.start();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Opens the actual frame application.
	 */
	private void openFrame() {
		clientFrame = new JFrame("Jagex");
		clientFrame.add(this);
		clientFrame.setVisible(true);
		clientFrame.setSize(765, 503);		
	}

	/**
	 * Reads the parameters text file, and stores the parameters.
	 */
	private void readParameters() {		
		parameters.put("worldid", "3594");
		parameters.put("members", "1");
		parameters.put("modewhat", "0");
		parameters.put("modewhere", "0");
		parameters.put("safemode", "0");
		parameters.put("game", "0");
		parameters.put("js", "1");
		parameters.put("lang", "0");
		parameters.put("affid", "0");
		parameters.put("lowmem", "0");
		parameters.put("settings", "kKmok3kJqOeN6D3mDdihco3oPeYN2KFy6W5--vZUbNA");
	}

	/*
	 * (non-Javadoc)
	 * @see java.applet.AppletStub#appletResize(int, int)
	 */
	@Override
	public void appletResize(int dimensionX, int dimensionY) {
		super.resize(new Dimension(dimensionX, dimensionY));
	}
	
	/*
	 * (non-Javadoc)
	 * @see java.applet.Applet#getParameter(java.lang.String)
	 */
	@Override
	public String getParameter(String paramName) {
		return (String) parameters.get(paramName);
	}
	
	/*
	 * (non-Javadoc)
	 * @see java.applet.Applet#getDocumentBase()
	 */
	@Override
	public URL getDocumentBase() {
		try {
			return new URL("http://127.0.0.1");
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	/*
	 * (non-Javadoc)
	 * @see java.applet.Applet#getCodeBase()
	 */
	@Override
	public URL getCodeBase() {
		try {
			return new URL("http://127.0.0.1");
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		return null;
	}
}